clear all;
%clc;
global C;
C = 1;
k =6;
h = 2^(-k);

% Sttzstellen
x = 0:h:1;
y = x;
[X,Y] = meshgrid(x(2:(end-1)),y(2:(end-1)));
s = length(x)-2;

a = C*h^2/2-4; % Diagonalelement

% A wird die Matrix fr das LGS und B dient zur Berechnung des Ladevektors
A = sparse(s^2,s^2);
B = sparse(s^2,s^2);

% Besetzung der Matrizen A,B
for i=1:s^2
    [I,J] = ind2sub([s,s],i);  % Koordinaten des Sttzpunktes
    if (I+1)<=s
        j = sub2ind([s,s],I+1,J); %Nummer des benachbarten Punktes
        A(i,j) = 2*(C*h^2/24+1/2);% Term fr vertikale Nachbarschaft
        B(i,j) = 2*h^2/24;
    end
    if (J+1)<=s
        j = sub2ind([s,s],I,J+1);
        A(i,j) = 2*(C*h^2/24+1/2); % Term fr horizontale Nachbarschaft
        B(i,j) = 2*h^2/24;
    end
    if (I+1<=s) && (J+1)<=s
        j = sub2ind([s,s],I+1,J+1); % schrge Nachbarschaft
        A(i,j) = 2*C*h^2/24;
        B(i,j) = 2*h^2/24;
    end
end

d1 = a*ones(s^2,1);
d2 = h^2/2*ones(s^2,1);
A = A+A'+spdiags(d1,0,s^2,s^2); A = sparse(A);
B = B+B'+spdiags(d2,0,s^2,s^2); B = sparse(B);

% Auswertung der Funktion f
F = f(X,Y);
realF = reshape(F, s^2, 1 );
load = B * realF;


v = A\load;
figure(1)
mesh(X,Y,reshape(v,s,s));
title('numerische Lsung');
figure(2)
mesh(X,Y,sin(2*pi*X).*sin(2*pi*Y));
title('exakte Lsung');
figure(3)
mesh(X,Y,abs(reshape(v,s,s)-sin(2*pi*X).*sin(2*pi*Y)));
title('Fehler des Absolutbetrags');
max(max(abs(reshape(v,s,s)-sin(2*pi*X).*sin(2*pi*Y))))
